package com.massivecraft.factions.cmd;

import com.massivecraft.factions.cmd.type.TypeMPlayer;
import com.massivecraft.factions.entity.BoardColl;
import com.massivecraft.factions.entity.FactionColl;
import com.massivecraft.factions.entity.MPlayer;
import com.massivecraft.massivecore.MassiveException;
import com.massivecraft.massivecore.command.requirement.RequirementIsntPlayer;
import com.massivecraft.massivecore.ps.PS;

import java.util.Collections;
import java.util.Set;

public class CmdFactionsSetOneLocation extends FactionsCommand {
    // -------------------------------------------- //
    // CONSTRUCT
    // -------------------------------------------- //

    private final boolean claim;

    public CmdFactionsSetOneLocation(boolean claim) {
        // Super
        super();

        this.setSetupEnabled(false);
        this.claim = claim;

        // Aliases
        this.addAliases("onel");

        this.addParameter(TypeMPlayer.get(), true, "player").setDesc("the player to claim for");

        // Requirements
        this.addRequirements(RequirementIsntPlayer.get());
    }

    @Override
    public void perform() throws MassiveException {
        // Args
        MPlayer player = this.readArgAt(0);

        if (!player.hasFaction()) {
            throw new MassiveException();
        }

        PS chunk = PS.valueOf(player.getPlayer().getLocation()).getChunk(true);
        Set<PS> chunks = Collections.singleton(chunk);

        // Apply / Inform
        if (this.claim) {
            if (!BoardColl.get().getFactionAt(chunk).isNone()) {
                throw new MassiveException().setMsg("<b>Only <h>wilderness<b> can be claimed using this method.");
            }
            msender.tryClaim(player.getFaction(), chunks);
        } else {
            if (!BoardColl.get().getFactionAt(chunk).equals(player.getFaction())) {
                throw new MassiveException();
            }
            msender.tryClaim(FactionColl.get().getNone(), chunks);
        }
    }

}
